From 7a94d6ea57ae6e85dbdca197133f9be9306b77dc Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 727/1001] Convert the pagure_pr widget


---

diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
new file mode 100644
index 0000000..6e3cf5a
--- /dev/null
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -0,0 +1,79 @@
+from __future__ import unicode_literals
+
+from hubs import validators
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+import requests
+
+pagure_url = "https://pagure.io/api/0"
+
+
+class PagurePRs(Widget):
+
+    name = "pagure_pr"
+    position = "right"
+    arguments = [
+        dict(
+            name="repo",
+            label="Repository",
+            default=None,
+            validator=validators.pagure_repo,
+            help="Pagure repo name.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/pagure_pr.html"
+    chrome = panel("Newest Open Pull Requests on Pagure")
+
+    def get_context(self, instance, *args, **kwargs):
+        get_prs = GetPRs(instance)
+        context = dict(repo=instance.config["repo"])
+        context.update(get_prs())
+        return context
+
+
+class GetPRs(CachedFunction):
+
+    def execute(self):
+        repo = self.instance.config["repo"]
+        url = '/'.join([pagure_url, repo, "pull-requests"])
+        response = requests.get(url)
+        data = response.json()
+        total_req = data['total_requests']
+        all_pr = list()
+
+        for request in data['requests']:
+            pr_project_user = None
+            if request['project']['parent']:
+                pr_project_user = request['project']['user']['username']
+
+            all_pr.append(
+                dict(
+                    pr_project_name=request['project']['name'],
+                    pr_project_user=pr_project_user,
+                    pr_id=request['id'],
+                    pr_title=request['title'][:45],
+                    pr_title_full=request['title'],
+                    pr_openedby=request['user']['name'],
+                    pr_assignee=request['assignee'],
+                )
+            )
+
+        return dict(
+            all_pr=all_pr,
+            total_req=total_req,
+        )
+
+    def should_invalidate(self, message):
+        category = message["topic"].split('.')[3]
+        if category != "pagure":
+            # TODO -- this could be honed in more to just PRs
+            return False
+        return (message['msg']['project']['name'] ==
+                self.instance.config['repo'])

